<template>
  <div class="settings-container">
    <ObTable
      ref="table"
      :columns="columns"
      :remote-opt="getSettings"
      add-button-text="Добавить индивидуальную наценку"
      :show-add-button="true"
      :functional-panel="true"
      :is-functional-group="false"
      :is-functional-sort="false"
      class="settings-table"
      @add="onAddClientMarkup"
    >
      <template v-slot:noneContent>
        <div class="title">Сейчас наценка одинаковая для всех клиентов.<br>Если хотите сделать индивидуальную наценку для клиента, нажмите “добавить”.</div>
        <ObButton
          label="Добавить индивидуальную наценку"
          type="flat"
          data-qa="add-markup-button"
          icon="plus"
          class="add-button"
          @click="onAddClientMarkup"
        />
      </template>
      <template v-slot:ftlUrban="{ data }">
        <ObInput
          v-model="data.item.markups.ftlUrban"
          placeholder="—"
          class="settings-table__input"
          @blur="onBlurField(data.item)"
        />
      </template>
      <template v-slot:ftlInterurban="{ data }">
        <ObInput
          v-model="data.item.markups.ftlInterurban"
          placeholder="—"
          class="settings-table__input"
          @blur="onBlurField(data.item)"
        />
      </template>
      <template v-slot:ftlInternational="{ data }">
        <ObInput
          v-model="data.item.markups.ftlInternational"
          placeholder="—"
          class="settings-table__input"
          @blur="onBlurField(data.item)"
        />
      </template>
      <template v-slot:multimodalAuto="{ data }">
        <ObInput
          v-model="data.item.markups.multimodalAuto"
          placeholder="—"
          class="settings-table__input"
          @blur="onBlurField(data.item)"
        />
      </template>
      <template v-slot:mainlineContainer="{ data }">
        <ObInput
          v-model="data.item.markups.mainlineContainer"
          placeholder="—"
          class="settings-table__input"
          @blur="onBlurField(data.item)"
        />
      </template>
      <template v-slot:mainlineRail="{ data }">
        <ObInput
          v-model="data.item.markups.mainlineRail"
          placeholder="—"
          class="settings-table__input"
          @blur="onBlurField(data.item)"
        />
      </template>
      <template v-slot:fullTrustOrder="{ data }">
        <ObInput
          v-model="data.item.markups.fullTrustOrder"
          placeholder="—"
          class="settings-table__input"
          @blur="onBlurField(data.item)"
        />
      </template>
      <template v-slot:partialTrustOrder="{ data }">
        <ObInput
          v-model="data.item.markups.partialTrustOrder"
          placeholder="—"
          class="settings-table__input"
          @blur="onBlurField(data.item)"
        />
      </template>
      <template v-slot:deleteButton="{ data }">
        <button
          class="delete-button"
          @click="deleteMarkupClient(data.item)"
        >
          <i class="icon close" />
        </button>
      </template>
    </ObTable>
    <ObModal
      ref="AddClientMarkupModal"
      title="Добавление индивидуальной наценки"
      size="lg"
    >
      <AddClientMarkupModal
        :data-source="currentSettings"
        @on-submitted="onSubmittedClientMarkupModal"
      />
    </ObModal>
  </div>
</template>

<script>
import api from '@/api'
import ObTable from 'common-components/src/obComponents/obTable'
import ObButton from 'common-components/src/obComponents/obButton'
import ObInput from 'common-components/src/obComponents/obInput'
import ObModal from 'common-components/src/obComponents/obModal'
import AddClientMarkupModal from './AddClientMarkupModal'

import { mapActions, mapGetters } from 'vuex'

export default {
  name: 'ClicarSettingsMarkupByClient',
  components: {
    ObTable,
    ObButton,
    ObInput,
    ObModal,
    AddClientMarkupModal
  },
  computed: {
    ...mapGetters({
      currentSettings: 'clicarSettings_3/currentSettings'
    }),
    columns () {
      return [
        {
          title: 'Клиент',
          key: 'clientTitle'
        },
        {
          headerHtml: () => `FTL гор.<br>доставка, %`,
          key: 'ftlUrban',
          slotName: 'ftlUrban',
          width: 100
        },
        {
          headerHtml: () => `FTL<br>межгород, %`,
          key: 'ftlInterurban',
          slotName: 'ftlInterurban',
          width: 100
        },
        {
          headerHtml: () => `FTL<br>Междуна-<br>родный, %`,
          key: 'ftlInternational',
          slotName: 'ftlInternational',
          width: 100
        },
        {
          headerHtml: () => `Мультимод.<br>автоплечи, %`,
          key: 'multimodalAuto',
          slotName: 'multimodalAuto',
          width: 100
        },
        {
          headerHtml: () => `Магистралка<br>контейнеры, %`,
          key: 'mainlineContainer',
          slotName: 'mainlineContainer',
          width: 100
        },
        {
          headerHtml: () => `Магистралка<br>вагоны, %`,
          key: 'mainlineRail',
          slotName: 'mainlineRail',
          width: 100
        },
        {
          headerHtml: () => `Заказы “Отпр.<br>груз” с полным<br>доверием БЦ, %`,
          key: 'fullTrustOrder',
          slotName: 'fullTrustOrder',
          width: 100
        },
        {
          headerHtml: () => `Заказы “Отпр.<br>груз” с частич.<br>доверием БЦ, %`,
          key: 'partialTrustOrder',
          slotName: 'partialTrustOrder',
          width: 100
        },
        {
          headerHtml: '',
          key: 'deleteButton',
          slotName: 'deleteButton',
          width: 15
        }
      ]
    }
  },
  methods: {
    ...mapActions({
      saveMarkupClientSettings: 'clicarSettings_3/saveMarkupClientSettings'
    }),
    async getSettings ({ page, query }) {
      return await api.clicar_setting_3.getMarkupClientSettings({ page, query })
    },
    onBlurField (data) {
      this.saveMarkupClientSettings({ data })
    },
    async deleteMarkupClient (data) {
      await api.clicar_setting_3.deleteMarkupClientSettings(data)
      this.$nextTick(() => {
        this.$refs.table?.loadData()
      })
    },
    onAddClientMarkup () {
      this.$refs.AddClientMarkupModal?.open()
    },
    onSubmittedClientMarkupModal () {
      this.$refs.AddClientMarkupModal?.close()
      this.$nextTick(() => {
        this.$refs.table?.loadData()
      })
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";
.settings-container {
  margin-left: -20px;
  margin-right: -20px;
}

.settings-table {
  margin-top: 30px;
  border-top: 1px $lavender solid;
  &__input {
    width: 60px;
    height: 30px;
    &::v-deep {
      .ob-input-wrap {
        height: 30px!important;
      }
      input {
        text-align: center!important;
      }
    }
  }
}

.add-button {
  &::v-deep {
    .icon {
      font-size: 24px;
      color: $color-grey-span;
    }
  }
}

.delete-button {
  margin: 0;
  padding: 0;
  border: none;
  background-color: transparent;
  outline: none;
  cursor: pointer;
  &:hover {
    opacity: 0.8;
  }
  .icon {
    font-size: 20px;
    color: $color-grey-span;
  }
}
</style>